<template>
    <div class="s">
        <v-card class="mx-auto textcont">
            <v-toolbar v-show="canCodeEdit" elevation="2" class="pd-0">
                <div class="violet">{{filePath}}</div>
                <v-divider vertical></v-divider>
                <v-select
                    :items="langs"
                    v-model="selected"
                    @change="changeLang"
                    label="请选择语言"
                    dense
                >
                </v-select>
                <v-divider vertical></v-divider>
                <v-label large>当前角色：{{ editRoleName }}</v-label>
                <v-divider vertical></v-divider>
                <v-btn v-show="false" @click="switchEditRole" color="accent" tile class="ml-3"
                    >切换角色</v-btn
                >
                <v-btn @click="sendData" color="accent" tile class="ml-3">提交</v-btn>
                <v-btn
                    v-show="canCodeEdit"
                    @click="quitCode"
                    color="green"
                    elevation="4"
                    class="ml-3 white--text"
                    >退出</v-btn
                >
                <v-divider vertical></v-divider>
                <v-btn
                    v-show="!canEdit"
                    @click="sendChangeRoleMsg"
                    elevation="4"
                    color="#0088cc"
                    class="ml-3 white--text"
                    >申请切换</v-btn
                >
                <v-btn
                    v-show="roomOwner"
                    @click="inviteUser"
                    elevation="4"
                    color="#0088cc"
                    class="ml-3 white--text"
                    >邀请</v-btn
                >
            </v-toolbar>
            <v-alert
                v-show="!canCodeEdit"
                border="top"
                colored-border
                type="info"
                elevation="4"
                ml="3"
                mr="3"
            >
                <v-row align="center" class="spacer" no-gutters>
                    <strong>请选择要编辑的文件</strong>
                </v-row>
            </v-alert>
            <v-alert
                v-show="hasChangeRoleReq"
                border="top"
                colored-border
                type="info"
                elevation="4"
                ml="3"
                mr="3"
            >
                <v-row align="center" class="spacer" no-gutters>
                    <v-col cols="4" sm="2" md="1">
                        <v-avatar size="36px" :color="reqUserColor">
                            <v-icon class="white--text" v-text="reqUserAvatar"></v-icon>
                        </v-avatar>
                    </v-col>
                    <v-col class="hidden-xs-only" cols="4" sm="2" md="1">
                        <strong v-html="reqUserNickName"></strong>
                    </v-col>
                    <v-col class="text-no-wrap" cols="15" sm="5">
                        <strong>请求切换编辑角色，您同意吗？</strong>
                    </v-col>
                    <v-col cols="4">
                        <v-btn @click="confirmChangeRole" color="#0088cc" class="white--text ml-3"
                            >同意</v-btn
                        >
                        <v-btn
                            @click="refuseChangeRole"
                            color="green"
                            normal
                            class="white--text ml-3"
                            >拒绝</v-btn
                        >
                    </v-col>
                </v-row>
            </v-alert>
            <v-alert
                v-show="hasInviteCodeReq"
                border="top"
                colored-border
                type="info"
                elevation="4"
                ml="3"
                mr="3"
            >
                <v-row align="center" class="spacer" no-gutters>
                    <v-col cols="4" sm="2" md="1">
                        <v-avatar :color="reqUserColor" size="36px">
                            <v-icon class="white--text" v-text="reqUserAvatar"></v-icon>
                        </v-avatar>
                    </v-col>
                    <v-col class="hidden-xs-only" cols="4" sm="2" md="1">
                        <strong v-html="reqUserNickName"></strong>
                    </v-col>
                    <v-col class="text-no-wrap" cols="15" sm="5">
                        <strong
                            >邀请你参与<span color="red" class="ml-1 mr-1">{{
                                inviteProjectName
                            }}</span
                            >项目<span color="red" class="ml-1 mr-1">{{ inviteFile }}</span
                            >文件的编程，您同意吗？</strong
                        >
                    </v-col>
                    <v-col cols="4">
                        <v-btn @click="confirmInviteCode" color="#0088cc" class="white--text ml-3"
                            >同意</v-btn
                        >
                        <v-btn
                            @click="refuseInviteCode"
                            color="green"
                            normal
                            class="white--text ml-3"
                            >拒绝</v-btn
                        >
                    </v-col>
                </v-row>
            </v-alert>
            <v-alert
                v-show="hasUserJoinCodeEdit"
                border="top"
                colored-border
                type="info"
                elevation="4"
                ml="3"
                mr="3"
            >
                <v-row align="center" class="spacer" no-gutters>
                    <v-col cols="4" sm="2" md="1">
                        <v-avatar :color="reqUserColor" size="36px">
                            <v-icon class="white--text" v-text="reqUserAvatar"></v-icon>
                        </v-avatar>
                    </v-col>
                    <v-col class="hidden-xs-only" cols="4" sm="2" md="1">
                        <strong v-html="reqUserNickName"></strong>
                    </v-col>
                    <v-col class="text-no-wrap" cols="15" sm="5">
                        <strong>加入文件的结对编程。</strong>
                    </v-col>
                    <v-col cols="4">
                        <v-btn @click="confirmUserJoinEdit" color="#0088cc" class="white--text ml-3"
                            >确定</v-btn
                        >
                    </v-col>
                </v-row>
            </v-alert>
            <v-alert
                v-show="hasAlertMsg"
                border="top"
                colored-border
                type="info"
                elevation="4"
                ml="3"
                mr="3"
            >
                <v-row align="center" class="spacer" no-gutters>
                    <v-col cols="4" sm="2" md="1">
                        <v-avatar :color="reqUserColor" size="36px">
                            <v-icon class="white--text" v-text="reqUserAvatar"></v-icon>
                        </v-avatar>
                    </v-col>
                    <v-col class="hidden-xs-only" cols="4" sm="2" md="1">
                        <strong v-html="reqUserNickName"></strong>
                    </v-col>
                    <v-col class="text-no-wrap" cols="15" sm="5">
                        <strong>{{ alertMsg }}</strong>
                    </v-col>
                    <v-col cols="4">
                        <v-btn @click="confirmAlertMsg" color="#0088cc" class="white--text ml-3"
                            >确定</v-btn
                        >
                    </v-col>
                </v-row>
            </v-alert>
            <codemirror
                ref="myCm"
                v-model="content"
                :options="cmOptions"
                class="code"
                v-on:changes="codeChange"
                v-on:scroll="codeScroll"
            ></codemirror>
        </v-card>
        <v-row justify="center">
            <v-dialog v-model="selectUserDialog" persistent class="mx-auto" max-width="400">
                <v-card>
                    <v-card-title class="headline-2">项目人员列表</v-card-title>
                    <v-divider></v-divider>
                    <v-list dense>
                        <v-list-item-group v-model="selectUser" color="primary">
                            <v-list-item v-for="user in projectUsers" :key="user.userName">
                                <v-list-item-icon>
                                    <v-icon>mdi-account</v-icon>
                                </v-list-item-icon>
                                <v-list-item-content>
                                    <v-list-item-title v-text="user.nickName"></v-list-item-title>
                                </v-list-item-content>
                            </v-list-item>
                        </v-list-item-group>
                    </v-list>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-tooltip top v-model="showTips">
                            <span>请选择要邀请的用户</span>
                        </v-tooltip>
                        <v-btn color="green" class="white--text" @click="selectUserDialog = false"
                            >取消</v-btn
                        >
                        <v-btn color="blue" class="white--text" @click="confirmUsers">确认</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </v-row>
        <v-row justify="center">
            <v-dialog v-model="confirmDialog" persistent class="mx-auto" max-width="400">
                <v-card>
                    <v-card-title class="headline-2">操作确认</v-card-title>
                    <v-divider></v-divider>
                    <v-spacer></v-spacer>
                    <v-row align="center" class="spacer mt-4" no-gutters>
                        <v-col class="text-no-wrap" cols="12" sm="5">
                            <strong class="ml-3 mr-3">{{ confirmMsg }}</strong>
                        </v-col>
                    </v-row>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="blue" class="white--text" @click="confirmResult">同意</v-btn>
                        <v-btn color="green" class="white--text" @click="refuseResult">拒绝</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </v-row>
    </div>
</template>

<script>
import { codemirror } from "vue-codemirror";
import "codemirror/mode/clike/clike.js";
import "codemirror/mode/javascript/javascript.js";
import "codemirror/mode/python/python.js";
import "codemirror/mode/markdown/markdown.js";
import "codemirror/mode/htmlmixed/htmlmixed.js";
import "codemirror/lib/codemirror.css";
import "codemirror/theme/idea.css";
import "codemirror/addon/fold/foldgutter.css";
import "codemirror/addon/fold/foldcode.js";
import "codemirror/addon/fold/foldgutter.js";
import "codemirror/addon/fold/xml-fold.js";
import "codemirror/addon/fold/indent-fold.js";
import "codemirror/addon/fold/brace-fold";
import "codemirror/addon/fold/markdown-fold.js";
import "codemirror/addon/fold/comment-fold.js";
import "codemirror/addon/selection/active-line";
import "codemirror/addon/edit/closebrackets";
import "codemirror/addon/edit/matchbrackets";

// import io from "socket.io-client";

export default {
    name: "writeBox",
    data: () => ({
        id: Math.random(),
        updateId: -1,
        roomId: 0,
        hasJoinRoom: false,
        roomOwner: false,
        userName: "",
        content: "",
        cmOptions: {
            tabSize: 4,
            mode: "clike", // 编辑语言
            theme: "idea", //主题
            styleActiveLine: true,
            lineNumbers: true, //显示行数
            line: true,
            foldgutter: true,
            gutters: ["CodeMirror-linenumbers", "CodeMirror-foldgutter", "CodeMirror-lint-markers"],
            lineWrapping: true, //代码折叠
            foldGutter: true,
            matchBrackets: true, //括号匹配
            autoCloseBrackets: true,
        },
        langs: [
            { text: "C/C++/Java", value: "clike" },
            { text: "JavaScript", value: "javascript" },
            { text: "Python", value: "python" },
            { text: "Markdown", value: "markdown" },
            { text: "HTML/CSS/JS", value: "htmlmixed" },
        ],
        selected: [],
        filePath: "",
        projectName: "",
        canEdit: false,
        // 交换角色
        reqUserName: "",
        reqUserNickName: "",
        reqUserAvatar: "",
        reqUserColor: "",
        hasChangeRoleReq: false,
        selectUserDialog: false,
        projectUsers: [],
        selectUser: null,
        showTips: false,
        // 邀请编程
        canInvite: false,
        hasInviteCodeReq: false,
        inviteRoomId: 0,
        inviteProjectName: "",
        inviteFile: "",
        // 用户加入
        hasUserJoinCodeEdit: false,
        confirmDialog: false,
        confirmMsg: "",
        sameFileContent: "",
        needReback: false,
        // alertMsg
        hasAlertMsg: false,
        alertMsg: "",
        confirmQuitDialog: false,
    }),
    components: {
        codemirror,
    },
    methods: {
        quitCode() {
            this.$axios({
                method: "post",
                url: `/codeEdit`,
                data: {
                    operation: "QuitRoom",
                    roomId: this.roomId,
                    userName: this.userName,
                    // nickName: this.$store.getters.nickName,
                    // avatar: this.$store.getters.userAvatar,
                    // color: this.$store.getters.userColor,
                    roomOwner: this.roomOwner,
                    hasJoinRoom: this.hasJoinRoom,
                },
            }).then(res => {
                if (res.status !== 200) {
                    this.alert("连接失败。\n请检查您的网络状态。");
                    return;
                }

                if (res.data.status === 2) {
                    this.$evtbus.$emit(
                        "CodeEdit.UserLeaveRoom",
                        this.roomId,
                        {
                            userName: this.userName,
                            nickName: this.$store.getters.nickName,
                            avatar: this.$store.getters.userAvatar,
                            color: this.$store.getters.userColor,
                        },
                        res.data.creatorChangeNotify,
                        res.data.editorChangeNotify,
                        res.data.newUser,
                    );
                }

                if (res.data.status === 1 || res.data.status === 2) {
                    const data = res.data.data;
                    this.roomId = data.roomId;
                    // 通知chat，房间号已改
                    this.$evtbus.$emit("CodeEdit.RoomHasChanged", this.roomId);

                    // 通知chat，清除聊天记录
                    this.$evtbus.$emit("CodeEdit.ClearChat", this.roomId);

                    this.projectName = "";
                    this.filePath = "";
                    this.roomOwner = false;
                    this.canInvite = false; // todo: 目前的逻辑是只有roomOwner才能邀请人
                    this.canEdit = false;
                    this.$refs.myCm.cminstance.doc.cantEdit = !this.canEdit;
                    this.content = "";
                    //this.$refs.myCm.handerCodeChange("");
                    this.hasJoinRoom = false;
                }
            });
        },
        codeChange() {
            const self = this;
            if (self.id === self.updateId) {
                this.$evtbus.$emit("CodeEdit.CodeRefresh", {
                    updateId: self.id,
                    roomId: self.roomId,
                    content: self.content,
                });
            }
        },
        codeScroll(editor) {
            const self = this;

            // 只有驾驶员能发scroll同步消息
            if(!self.canEdit){
                return;
            }

            if (self.id === self.updateId) {
                this.$evtbus.$emit("CodeEdit.CodeScroll", {
                    updateId: self.id,
                    roomId: self.roomId,
                    left: editor.doc.scrollLeft,
                    top: editor.doc.scrollTop,
                });
            }
        },
        sendData() {
            if (this.content.length > 400000) {
                alert("哦，亲爱的用户，我们不可以上传斗破苍穹！");
                return;
            }

            this.$evtbus.$emit(
                "CodeEdit.SaveFile",
                this.projectName,
                this.filePath,
                this.roomId,
                this.userName,
                this.content,
            );
        },
        readFile() {
            if (!this.filePath.length) {
                this.alert("文件路径不得为空！");
                return;
            }

            this.$axios({
                method: "post",
                url: `/projectfile`,
                data: {
                    operation: "GetFile",
                    projectName: this.projectName,
                    path: this.filePath,
                },
            }).then(res => {
                // console.log(res);
                if (res.status === 200) {
                    const data = res.data;
                    if (data.status === "OK") {
                        this.content = data.content;
                    }
                } else {
                    this.alert("连接失败。\n请检查您的网络状态。");
                }
            });
        },
        changeLang() {
            this.cmOptions.mode = this.selected;
            this.$set(this.cmOptions, "mode", this.selected);
        },
        changeFile(e) {
            // console.log(e.target.files);
            this.fileName = e.target.files;
        },
        changeProject() {
            this.projectName = this.$store.getters.projectName;
        },
        switchEditRole() {
            this.canEdit = !this.canEdit;
        },
        sendChangeRoleMsg() {
            this.$evtbus.$emit("CodeEdit.ChangeEditRoleReq", {
                roomId: this.roomId,
                userName: this.userName,
                nickName: this.$store.getters.nickName,
                avatar: this.$store.getters.userAvatar,
                color: this.$store.getters.userColor,
            });
        },
        confirmChangeRole() {
            this._treatChangeRole(true);
        },
        refuseChangeRole() {
            this._treatChangeRole(false);
        },
        _treatChangeRole(confirm) {
            this.canEdit = !confirm;
            this.$refs.myCm.cminstance.doc.cantEdit = confirm;

            // 发确认回讯
            this.$evtbus.$emit("CodeEdit.ChangeEditRoleReply", {
                roomId: this.roomId,
                userName: this.userName,
                reqUserName: this.reqUserName,
                confirm: confirm,
            });

            // 置确认消息标识 = false
            this.hasChangeRoleReq = false;
        },
        inviteUser() {
            const self = this;
            this.$axios({
                method: "post",
                url: `/project`,
                data: {
                    operation: "ProjectUsers",
                    projectName: this.projectName,
                    userName: this.userName,
                },
            }).then(function(res) {
                if (res.status === 200) {
                    const data = res.data;
                    if (data.status === "OK") {
                        self.projectUsers = data.data;
                        // console.log(self.projectUsers);
                    }
                } else {
                    this.alert("连接失败。\n请检查您的网络状态。");
                }
            });

            this.selectUserDialog = true;
        },
        confirmInviteCode() {
            this._treatInviteCode(true);
        },
        refuseInviteCode() {
            this._treatInviteCode(false);
        },
        _treatInviteCode(confirm) {
            if (confirm) {
                // console.log("invite code confirm = true, roomId = ", this.roomId);

                // 向后端申请处理数据
                this.$axios({
                    method: "post",
                    url: `/codeEdit`,
                    data: {
                        operation: "ChangeRoom",
                        projectName: this.projectName,
                        filePath: this.filePath,
                        roomId: this.roomId,
                        userName: this.userName,
                        // nickName: this.$store.getters.nickName,
                        // avatar: this.$store.getters.userAvatar,
                        // color: this.$store.getters.userColor,
                        roomOwner: this.roomOwner,
                        hasJoinRoom: this.hasJoinRoom,
                        targetRoomId: this.inviteRoomId,
                    },
                }).then(res => {
                    if (res.status !== 200) {
                        this.alert("连接失败。\n请检查您的网络状态。");
                        return;
                    }

                    if (res.data.leaveNotify) {
                        // 通知原房间其它人离开
                        const originRoomId = res.data.originRoomId;
                        this.$evtbus.$emit(
                            "CodeEdit.UserLeaveRoom",
                            originRoomId,
                            {
                                userName: this.userName,
                                nickName: this.$store.getters.nickName,
                                avatar: this.$store.getters.userAvatar,
                                color: this.$store.getters.userColor,
                            },
                            res.data.creatorChangeNotify,
                            res.data.editorChangeNotify,
                            res.data.newUser,
                        );
                    }

                    if (res.data.status === 1) {
                        // 正常开房间
                        this.roomId = this.inviteRoomId;
                        // 通知chat，房间号已改
                        this.$evtbus.$emit("CodeEdit.RoomHasChanged", this.roomId);
                        this.projectName = this.inviteProjectName;
                        this.filePath = this.inviteFile;
                        this.roomOwner = false;
                        this.canInvite = false;
                        this.canEdit = false;
                        this.$refs.myCm.handerCodeChange(res.data.fileContent);
                        this.$refs.myCm.cminstance.doc.cantEdit = !this.canEdit;
                        this.hasJoinRoom = true;

                        // 申请加入room
                        this.$evtbus.$emit("CodeEdit.JoinRoom", {
                            userId: 1,
                            userName: this.userName,
                            room: this.roomId,
                        });

                        return;
                    }
                });
            }

            // console.log(
            //     "invite code reply = true, roomId = ",
            //     this.inviteRoomId,
            //     " username = ",
            //     this.reqUserName,
            // );
            // 发确认回讯
            this.$evtbus.$emit("CodeEdit.InviteUserCodeReply", {
                roomId: this.inviteRoomId,
                userName: this.reqUserName,
                confirm: confirm,
            });

            // 置确认消息标识 = false
            this.hasInviteCodeReq = false;
        },
        confirmUsers() {
            if (this.selectUser === undefined || this.selectUser === null) {
                this.showTips = true;
                return;
            }

            this.showTips = false;
            const user = this.projectUsers.find((usr, index) => index === this.selectUser);
            // console.log(this.selectUser, user.userName);
            this.selectUserDialog = false;

            this.$evtbus.$emit("CodeEdit.InviteUserCodeReq", {
                roomId: this.roomId,
                userName: this.userName,
                nickName: this.$store.getters.nickName,
                avatar: this.$store.getters.userAvatar,
                color: this.$store.getters.userColor,
                inviteUserName: user.userName,
                inviteProjectName: this.projectName,
                inviteFile: this.filePath,
            });
        },
        confirmUserJoinEdit() {
            this.hasUserJoinCodeEdit = false;
        },
        confirmResult() {
            // 同意，
            this.roomId = this.sameFileEditRoomId;
            // 通知chat，房间号已改
            this.$evtbus.$emit("CodeEdit.RoomHasChanged", this.roomId);
            this.roomOwner = false;
            this.canInvite = false;
            this.canEdit = false;
            this.$refs.myCm.handerCodeChange(this.sameFileContent);
            this.$refs.myCm.cminstance.doc.cantEdit = !this.canEdit;
            this.hasJoinRoom = true;

            this.confirmDialog = false;
            this.confirmMsg = "";
            this.sameFileContent = "";

            // 加入房间
            // console.log("JoinRoom: ", this.roomId, this.userName);
            this.$evtbus.$emit("CodeEdit.JoinRoom", {
                userId: 1,
                userName: this.userName,
                room: this.roomId,
            });

            // 发出通知，通知加入房间的人，
            this.$evtbus.$emit("CodeEdit.NotifyUserJoin", this.sameFileEditRoomId, {
                userName: this.userName,
                nickName: this.$store.getters.nickName,
                avatar: this.$store.getters.userAvatar,
                color: this.$store.getters.userColor,
            });

            if (this.needReback) {
                this.needReback = false;

                this.$axios({
                    method: "post",
                    url: `/codeEdit`,
                    data: {
                        operation: "CloseRoom",
                        roomId: this.originRoomId,
                    },
                }).then(res => {
                    if (res.status !== 200) {
                        this.alert("连接失败。\n请检查您的网络状态。");
                        return;
                    }
                });
            }
        },
        refuseResult() {
            // 拒绝，恢复参数
            this.confirmDialog = false;
            this.confirmMsg = "";
            this.sameFileContent = "";
            this.projectName = "";
            this.filePath = "";
            this.hasJoinRoom = false;
            this.roomOwner = false;
            this.canInvite = false;
            this.canEdit = false;
            this.$refs.myCm.cminstance.doc.cantEdit = !this.canEdit;
            this.needReback = false;
        },
        confirmAlertMsg() {
            this.hasAlertMsg = false;
            this.alertMsg = "";
        },
        // 计算用户房间的角色：没有编程 === 1；开始编程（房间拥有者）=== 2；开始编程（普通人员）=== 3；
        userRoomRole() {
            if (!this.hasJoinRoom) {
                return 1;
            }

            return this.roomOwner ? 2 : 3;
        },
        interval(func, wait) {
            const interv = (function(w) {
                return () => {
                    setTimeout(interv, w);
                    func.call(null);
                };
            })(wait);

            setTimeout(interv, wait);
        },
    },
    mounted() {
        this.userName = this.$store.getters.userName;
        this.roomId = new Date().getMilliseconds();

        // 通知chat，房间号
        this.$evtbus.$emit("CodeEdit.RoomHasChanged", this.roomId);

        this.interval(() => {
            this.$evtbus.$emit("CodeEdit.UserTouchServer", {
                userName: this.userName,
                roomId: this.roomId,
            });
        }, 5000);

        this.roomOwner = false;
        this.canInvite = false;
        this.hasJoinRoom = false;
        this.canEdit = false;
        this.$refs.myCm.cminstance.doc.cantEdit = true;

        this.updateId = this.id;

        // 进入结对编程界面，有三种可能：
        // 1、没有编程               === 1
        // 2、开始编程（房间拥有者）   === 2
        // 3、开始编程（普通人员）     === 3
        // 操作可能：
        // 1、自己改变文档；2、退出编程；3、被人邀请
        // 改变文档：
        //    对于可能1，就是简单的新建room，成为creator
        //    对于可能2，
        //        如果room里还有其他人，提醒用户，通知room里的其他人，指定其他人的第一个人为creator，离开room，新开room，成为creator
        //        如果room里没有其他人，改变房间数据（项目名称，文件名），继续留在房间做creator
        //    对于可能3，
        //        如果room里还有其他人，提醒用户，通知room里的其他人，离开room，新开room，成为creator
        //        如果room里没有其他人，改变房间数据（项目名称，文件名），继续留在房间做creator
        // 退出编程：
        //    对于可能2，
        //        如果room里还有其他人，提醒用户，通知room里的其他人，指定其他人的第一个人为creator，离开room
        //        如果room里没有其他人，直接退出room，销毁room数据
        //    对于可能3，
        //        如果room里还有其他人，提醒用户，通知room里的其他人，离开room
        //        如果room里没有其他人，直接退出room，销毁room数据
        // 被人邀请：
        //    对于可能1，就是简单的同意和拒绝，同意就加入
        //    对于可能2，
        //        如果room里还有其他人，提醒用户，通知room里的其他人，指定其他人的第一个人为creator，离开room，进入邀请人room，成为普通人员
        //        如果room里没有其他人，销毁room数据，离开room，进入邀请人room，成为普通人员
        //    对于可能3，
        //        如果room里还有其他人，提醒用户，通知room里的其他人，离开room，进入邀请人room，成为普通人员
        //        如果room里没有其他人，销毁room数据，离开room，进入邀请人room，成为普通人员
        this.$evtbus.$on("CodeEdit.FileHasSelected", (projectName, file) => {
            //console.log(projectName, file);
            if (!projectName || !file) {
                return;
            }

            const changeFile = this.projectName !== projectName || this.filePath !== file;
            if (!changeFile) {
                return;
            }

            if (this.hasJoinRoom) {
                const c = confirm(
                    "编辑新的代码，将退出当前代码编辑对话, 然后请点击你要编辑的新文件，你确定吗？",
                );
                if (!c) {
                    return;
                }

                this.quitCode();
                return;
            }

            this.projectName = projectName;
            this.filePath = file;

            // console.log("userRoomRole:===", this.userRoomRole());

            // 没有开过房间，向后台开房间，并设置房间号，roomOwner为true
            // this.roomId = new Date().getMilliseconds(); // 当前时间的毫秒数作为房间号，不会重复
            // this.roomOwner = true;
            // 后台申请开房间
            // console.log("begin CeateRoom: ");
            this.$axios({
                method: "post",
                url: `/codeEdit`,
                data: {
                    operation: "CreateRoom",
                    projectName: this.projectName,
                    filePath: this.filePath,
                    roomId: this.roomId,
                    userName: this.userName,
                    // nickName: this.$store.getters.nickName,
                    // avatar: this.$store.getters.userAvatar,
                    // color: this.$store.getters.userColor,
                    roomOwner: this.roomOwner,
                    hasJoinRoom: this.hasJoinRoom,
                },
            }).then(res => {
                if (res.status !== 200) {
                    alert("连接失败。\n请检查您的网络状态。");
                    return;
                }

                // console.log("createRoom ok: ", res.data);
                if (res.data.leaveNotify) {
                    // 通知原房间其它人离开
                    const originRoomId = res.data.originRoomId;
                    this.$evtbus.$emit(
                        "CodeEdit.UserLeaveRoom",
                        originRoomId,
                        {
                            userName: this.userName,
                            nickName: this.$store.getters.nickName,
                            avatar: this.$store.getters.userAvatar,
                            color: this.$store.getters.userColor,
                        },
                        res.data.creatorChangeNotify,
                        res.data.editorChangeNotify,
                        res.data.newUser,
                    );
                }

                if (res.data.status === 1) {
                    // 正常开房间
                    const data = res.data.data;
                    this.roomId = data.roomId;
                    // 通知chat，房间号
                    this.$evtbus.$emit("CodeEdit.RoomHasChanged", this.roomId);
                    this.roomOwner = data.roomOwner;
                    this.canInvite = data.roomOwner; // todo: 目前的逻辑是只有roomOwner才能邀请人
                    this.canEdit = true;

                    this.readFile();

                    this.$refs.myCm.cminstance.doc.cantEdit = !this.canEdit;
                    this.hasJoinRoom = true;

                    // 加入房间
                    // console.log("JoinRoom: ", this.roomId, this.userName);
                    this.$evtbus.$emit("CodeEdit.JoinRoom", {
                        userId: 1,
                        userName: this.userName,
                        room: this.roomId,
                    });

                    return;
                }

                if (res.data.status === 2) {
                    // 加入别人房间
                    // 弹出对话框提醒用户，是否要加入别人的房间，如果不同意，则清除参数，否者加入别人房间，并提醒其他人
                    this.confirmDialog = true;
                    this.confirmMsg = "文件已经有人在编辑，你想加入吗？";
                    this.sameFileEditRoomId = res.data.data.roomId;
                    this.sameFileContent = res.data.data.fileContent;
                    this.needReback = res.data.needReback;
                    this.originRoomId = res.data.originRoomId;
                    return;
                }
            });
        });

        // todo：逻辑不太对，应该从treeview传递过来
        // this.$evtbus.$on("projectchange", () => {
        // this.changeProject();
        // });

        const self = this;
        this.$evtbus.$on("CodeEdit.CodeUpdate", function(codeContent) {
            if (!codeContent) {
                return;
            }

            if (codeContent.updateId === self.id || codeContent.roomId !== self.roomId) {
                return;
            }

            self.updateId = codeContent.updateId;
            //self.content = codeContent.content;
            self.$refs.myCm.handerCodeChange(codeContent.content);
            self.$refs.myCm.cminstance.doc.cantEdit = !self.canEdit;
            setTimeout(function() {
                self.updateId = self.id;
            }, 1000);
        });

        this.$evtbus.$on("CodeEdit.EditorScrollUpdate", function(codeContent) {
            if (!codeContent) {
                return;
            }

            if (codeContent.updateId === self.id || codeContent.roomId !== self.roomId) {
                return;
            }

            self.updateId = codeContent.updateId;
            self.$refs.myCm.cminstance.scrollTo(codeContent.left, codeContent.top);
            setTimeout(function() {
                self.updateId = self.id;
            }, 1000);
        });

        this.$evtbus.$on("CodeEdit.ChangeEditRoleReq.ServerTransfer", function(reqData) {
            if (!reqData) {
                return;
            }

            if (reqData.userName === self.userName || reqData.roomId !== self.roomId || !self.canEdit) {
                return;
            }

            // 置确认消息标识 = true
            self.reqUserName = reqData.userName;
            self.reqUserNickName = reqData.nickName;
            self.reqUserAvatar = reqData.avatar;
            self.reqUserColor = reqData.color;
            self.hasChangeRoleReq = true;
        });

        this.$evtbus.$on("CodeEdit.ChangeEditRoleReply.ServerTransfer", function(data) {
            if (!data) {
                return;
            }

            if (data.reqUserName === self.userName && data.roomId === self.roomId) {
                if (data.confirm) {
                    alert("同意了");
                } else {
                    alert("拒绝");
                }
                self.canEdit = data.confirm;
                self.$refs.myCm.cminstance.doc.cantEdit = !data.confirm;
            }
        });

        this.$evtbus.$on("CodeEdit.InviteUserCodeReq.ServerTransfer", function(reqData) {
            if (!reqData) {
                return;
            }

            if (
                reqData.userName === self.userName ||
                //reqData.roomId !== self.roomId ||
                reqData.inviteUserName !== self.userName
            ) {
                return;
            }

            self.reqUserName = reqData.userName;
            self.reqUserNickName = reqData.nickName;
            self.reqUserAvatar = reqData.avatar;
            self.reqUserColor = reqData.color;
            self.inviteRoomId = reqData.roomId;
            self.inviteProjectName = reqData.inviteProjectName;
            self.inviteFile = reqData.inviteFile;
            // 置确认消息标识 = true
            self.hasInviteCodeReq = true;

            // console.log(
            //     "CodeEdit.InviteUserCodeReq.ServerTransfer: my RoomId: ",
            //     self.roomId,
            //     "target RoomId: ",
            //     self.inviteRoomId,
            // );
        });

        this.$evtbus.$on("CodeEdit.InviteUserCodeReply.ServerTransfer", function(data) {
            if (!data) {
                return;
            }

            if (data.userName === self.userName && data.roomId === self.roomId) {
                if (data.confirm) {
                    self.codeChange();
                    alert("同意了");
                } else {
                    alert("拒绝");
                }
                // self.canEdit = data.confirm;
                // self.$refs.myCm.cminstance.doc.cantEdit = !data.confirm;
            }
        });

        this.$evtbus.$on("CodeEdit.HasUserJoinCodeEdit", data => {
            const user = data.user;
            if (user.userName === self.userName) {
                return;
            }

            self.reqUserName = user.userName;
            self.reqUserNickName = user.nickName;
            self.reqUserAvatar = user.avatar;
            self.reqUserColor = user.color;
            self.hasUserJoinCodeEdit = true;
        });

        this.$evtbus.$on(
            "CodeEdit.HasUserQuitEdit",
            (user, creatorChangeNotify, editorChangeNotify, newUser) => {
                if (user.userName === self.userName) {
                    return;
                }

                self.reqUserName = user.userName;
                self.reqUserNickName = user.nickName;
                self.reqUserAvatar = user.avatar;
                self.reqUserColor = user.color;

                self.hasAlertMsg = true;
                self.alertMsg = "退出了编程。";

                // 如果新roomCreator和驾驶员是用户
                if (self.userName === newUser) {
                    if (creatorChangeNotify || editorChangeNotify) {
                        self.alertMsg += "您";
                    }
                    if (creatorChangeNotify) {
                        self.alertMsg += "现在是编程发起者了，可以邀请其它人参与编程。";
                        self.roomOwner = true;
                        self.canInvite = true;
                    }
                    if (editorChangeNotify) {
                        self.alertMsg += "现在是驾驶员了。";
                        self.canEdit = true;
                        this.$refs.myCm.cminstance.doc.cantEdit = !self.canEdit;
                    }
                }
            },
        );

        this.$evtbus.$on("CodeEdit.HasMsg", data => {
            if (data.roomId !== self.roomId) {
                return;
            }

            if (data.isAllMsg || data.userName === self.userName) {
                self.hasAlertMsg = true;
                self.reqUserName = "";
                self.reqUserNickName = "";
                self.reqUserColor = "";
                self.reqUserAvatar = "";

                if (data.userName === self.userName) {
                    self.alertMsg = data.message;
                } else {
                    self.alertMsg = `${data.userName} ${data.message}`;
                }
            }
            return;
        });

        this.$evtbus.$on("CodeEdit.ProjectUserRemoved", data => {
            console.log(data);

            if (data.roomId !== self.roomId) {
                return;
            }

            // 不是被删除人，就是通知下
            if (data.userName !== self.userName) {
                self.hasAlertMsg = true;
                self.alertMsg = data.message;
                self.reqUserName = "";
                self.reqUserNickName = "";
                self.reqUserColor = "";
                self.reqUserAvatar = "";
            } else {
                // 是被删除人，弹出窗口确认
                alert("你已经从项目中删除，将退出编程。");
                self.quitCode();
            }

            return;
        });

        this.$evtbus.$on("CodeEdit.ProjectRemoved", data => {
            console.log(data, self.roomId);

            if (data.roomId !== self.roomId || data.userName === self.userName) {
                return;
            }

            alert(data.message);
            self.quitCode();

            return;
        });

        // 判断下自己是否已经在房间里，如果在则恢复现场数据
        this.$axios({
            method: "post",
            url: `/codeEdit`,
            data: {
                operation: "IsInRoom",
                projectName: this.projectName,
                filePath: this.filePath,
                roomId: this.roomId,
                userName: this.userName,
                roomOwner: this.roomOwner,
            },
        }).then(res => {
            if (res.status !== 200) {
                this.alert("连接失败。\n请检查您的网络状态。");
                return;
            }

            if (res.data.status === "OK") {
                // 已经在房间里
                const data = res.data.data;
                this.roomId = data.roomId;
                // 通知chat，房间号已改
                this.$evtbus.$emit("CodeEdit.RoomHasChanged", this.roomId);
                this.projectName = data.projectName;
                this.$evtbus.$emit("CodeEdit.ProjectNameInit", this.projectName);
                this.filePath = data.file;
                this.roomOwner = data.roomOwner;
                this.canInvite = data.roomOwner; // todo: 目前的逻辑是只有roomOwner才能邀请人

                this.canEdit = data.isEditor;
                this.$refs.myCm.handerCodeChange(data.fileContent);
                this.$refs.myCm.cminstance.doc.cantEdit = !this.canEdit;
                this.hasJoinRoom = true;

                // 加入房间
                // console.log("JoinRoom: ", this.roomId, this.userName);
                this.$evtbus.$emit("CodeEdit.JoinRoom", {
                    userId: 1,
                    userName: this.userName,
                    room: this.roomId,
                });

                return;
            } else {
                this.roomOwner = false;
                this.canInvite = false;

                this.canEdit = false;
                this.$refs.myCm.handerCodeChange("");
                this.$refs.myCm.cminstance.doc.cantEdit = !this.canEdit;
                this.hasJoinRoom = false;
            }
        });
    },
    computed: {
        canCodeEdit() {
            return this.hasJoinRoom && this.projectName !== "" && this.filePath !== "";
        },
        editRoleName() {
            return this.canEdit ? "驾驶员" : "观察者";
        },
        changeEditRoleMsg() {
            return `${this.reqUserName}请求切换编辑角色，您同意吗？`;
        },
    },
};
</script>

<style lang="scss">
.s {
    margin-top: 70px;
}

.violet {
    color: #680253;
}

.code {
    .CodeMirror-wrap {
        height: calc(100vh - 132px);
    }
    .CodeMirror-gutters {
        z-index: 0;
    }
    .CodeMirror-gutter-elt {
        z-index: 0;
    }
    .CodeMirror-activeline-gutter {
        z-index: 0;
    }
    .CodeMirror-vscrollbar {
        z-index: 0;
    }
}
</style>
